﻿<!DOCTYPE html>
<html lang="en">

<head>
    <!-- Required meta tags-->
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="STM32 Framework">
    <meta name="author" content="Dong Tran Thien">
    <meta name="keywords" content="upware.io">

    <!-- Title Page-->
    <title>upware</title>
    <link rel="icon" href="https://upware1.b-cdn.net/introPage/img/favicon.png" type="image/png">

    <!-- Fontfaces CSS-->
    <link href="https://upware1.b-cdn.net/dashboardPage/css/font-face.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/font-awesome-4.7/css/font-awesome.min.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/font-awesome-5/css/fontawesome-all.min.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/mdi-font/css/material-design-iconic-font.min.css" rel="stylesheet" media="all">

    <!-- Bootstrap CSS-->
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/bootstrap-4.1/bootstrap.min.css" rel="stylesheet" media="all">

    <!-- Vendor CSS-->
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/animsition/animsition.min.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/bootstrap-progressbar/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/wow/animate.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/css-hamburgers/hamburgers.min.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/slick/slick.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/select2/select2.min.css" rel="stylesheet" media="all">
    <link href="https://upware1.b-cdn.net/dashboardPage/vendor/perfect-scrollbar/perfect-scrollbar.css" rel="stylesheet" media="all">

    <!-- Main CSS-->
    <link href="https://upware1.b-cdn.net/dashboardPage/css/theme.css" rel="stylesheet" media="all">

</head>

<body class="animsition">
    <div class="page-wrapper">
        <!-- HEADER DESKTOP-->
        <header class="header-desktop3 d-none d-lg-block">
            <div class="section__content section__content--p35">
                <div class="header3-wrap">
                    <div class="header__logo">
                        <a href="#">
                            <img src="https://upware1.b-cdn.net/dashboardPage/images/icon/logo.png" alt="CoolAdmin" />
                        </a>
                    </div>
                    <div class="header__navbar">
                        <ul class="list-unstyled">
                            <li class="has-sub">
                                <a href="#">
                                    <i class="fas fa-tachometer-alt"></i>Dashboard
                                    <span class="bot-line"></span>
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <i class="fas fa-shopping-basket"></i>
                                    <span class="bot-line"></span>eCommerce
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <i class="fas fa-trophy"></i>
                                    <span class="bot-line"></span>Features
                                </a>
                            </li>
                            <li class="has-sub">
                                <a href="#">
                                    <i class="fas fa-copy"></i>
                                    <span class="bot-line"></span>Pages
                                </a>
                                <ul class="header3-sub-list list-unstyled">
                                    <li>
                                        <a href="#">Login</a>
                                    </li>
                                    <li>
                                        <a href="#">Register</a>
                                    </li>
                                    <li>
                                        <a href="#">Forget Password</a>
                                    </li>
                                </ul>
                            </li>
                        </ul>
                    </div>
                    <div class="header__tool">
                        <div class="header-button-item has-noti js-item-menu">
                            <i class="zmdi zmdi-notifications"></i>
                            <div class="notifi-dropdown notifi-dropdown--no-bor js-dropdown">
                                <div class="notifi__title">
                                    <p>You have 3 Notifications</p>
                                </div>
                                <div class="notifi__item">
                                    <div class="bg-c1 img-cir img-40">
                                        <i class="zmdi zmdi-email-open"></i>
                                    </div>
                                    <div class="content">
                                        <p>You got a email notification</p>
                                        <span class="date">April 12, 2018 06:50</span>
                                    </div>
                                </div>
                                <div class="notifi__item">
                                    <div class="bg-c2 img-cir img-40">
                                        <i class="zmdi zmdi-account-box"></i>
                                    </div>
                                    <div class="content">
                                        <p>Your account has been blocked</p>
                                        <span class="date">April 12, 2018 06:50</span>
                                    </div>
                                </div>
                                <div class="notifi__item">
                                    <div class="bg-c3 img-cir img-40">
                                        <i class="zmdi zmdi-file-text"></i>
                                    </div>
                                    <div class="content">
                                        <p>You got a new file</p>
                                        <span class="date">April 12, 2018 06:50</span>
                                    </div>
                                </div>
                                <div class="notifi__footer">
                                    <a href="#">All notifications</a>
                                </div>
                            </div>
                        </div>
                        <div class="header-button-item js-item-menu">
                            <i class="zmdi zmdi-settings"></i>
                            <div class="setting-dropdown js-dropdown">
                                <div class="account-dropdown__body">
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-account"></i>Account
                                        </a>
                                    </div>
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-settings"></i>Setting
                                        </a>
                                    </div>
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-money-box"></i>Billing
                                        </a>
                                    </div>
                                </div>
                                <div class="account-dropdown__body">
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-globe"></i>Language
                                        </a>
                                    </div>
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-pin"></i>Location
                                        </a>
                                    </div>
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-email"></i>Email
                                        </a>
                                    </div>
                                    <div class="account-dropdown__item">
                                        <a href="#">
                                            <i class="zmdi zmdi-notifications"></i>Notifications
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="account-wrap">
                            <div class="account-item account-item--style2 clearfix js-item-menu">
                                <div class="image">
                                    <img id="avatarDesktopOutside" alt="" />
                                </div>
                                <div class="content">
                                    <a id="nameDisplayOutsideDesktop" class="js-acc-btn" href="#"></a>
                                </div>
                                <div class="account-dropdown js-dropdown">
                                    <div class="info clearfix">
                                        <div class="image">
                                            <a href="#">
                                                <img id="avatarDesktopInside" alt="" />
                                            </a>
                                        </div>
                                        <div class="content">
                                            <h5 class="name">
                                                <a id="nameDisplayInsideDesktop" href="#"></a>
                                            </h5>
                                            <span id="emailDesktop" class="email"></span>
                                        </div>
                                    </div>
                                    <div class="account-dropdown__body">
                                        <div class="account-dropdown__item">
                                            <a href="#">
                                                <i class="zmdi zmdi-account"></i>Account
                                            </a>
                                        </div>
                                        <div class="account-dropdown__item">
                                            <a href="#">
                                                <i class="zmdi zmdi-settings"></i>Setting
                                            </a>
                                        </div>
                                        <div class="account-dropdown__item">
                                            <a href="#">
                                                <i class="zmdi zmdi-money-box"></i>Billing
                                            </a>
                                        </div>
                                    </div>
                                    <div id="logOut" class="account-dropdown__footer">
                                        <a>
                                            <i class="zmdi zmdi-power"></i>Logout
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </header>
        <!-- END HEADER DESKTOP-->
        <!-- HEADER MOBILE-->
        <header class="header-mobile header-mobile-2 d-block d-lg-none">
            <div class="header-mobile__bar">
                <div class="container-fluid">
                    <div class="header-mobile-inner">
                        <a class="logo" href="#">
                            <img src="https://upware1.b-cdn.net/dashboardPage/images/icon/logo.png" alt="CoolAdmin" />
                        </a>
                        <button class="hamburger hamburger--slider" type="button">
                            <span class="hamburger-box">
                                <span class="hamburger-inner"></span>
                            </span>
                        </button>
                    </div>
                </div>
            </div>
            <nav class="navbar-mobile">
                <div class="container-fluid">
                    <ul class="navbar-mobile__list list-unstyled">
                        <li class="has-sub">
                            <a class="js-arrow" href="#">
                                <i class="fas fa-tachometer-alt"></i>Dashboard
                            </a>
                            <ul class="navbar-mobile-sub__list list-unstyled js-sub-list">
                                <li>
                                    <a href="#">Dashboard 1</a>
                                </li>
                                <li>
                                    <a href="#">Dashboard 2</a>
                                </li>
                                <li>
                                    <a href="#">Dashboard 3</a>
                                </li>
                                <li>
                                    <a href="#">Dashboard 4</a>
                                </li>
                            </ul>
                        </li>
                        <li>
                            <a href="#">
                                <i class="fas fa-chart-bar"></i>Charts
                            </a>
                        </li>
                        <li>
                            <a href="#">
                                <i class="fas fa-table"></i>Tables
                            </a>
                        </li>
                        <li>
                            <a href="#">
                                <i class="far fa-check-square"></i>Forms
                            </a>
                        </li>
                        <li>
                            <a href="#">
                                <i class="fas fa-calendar-alt"></i>Calendar
                            </a>
                        </li>
                        <li>
                            <a href="#">
                                <i class="fas fa-map-marker-alt"></i>Maps
                            </a>
                        </li>
                        <li class="has-sub">
                            <a class="js-arrow" href="#">
                                <i class="fas fa-copy"></i>Pages
                            </a>
                            <ul class="navbar-mobile-sub__list list-unstyled js-sub-list">
                                <li>
                                    <a href="#">Login</a>
                                </li>
                                <li>
                                    <a href="#">Register</a>
                                </li>
                                <li>
                                    <a href="#">Forget Password</a>
                                </li>
                            </ul>
                        </li>
                        <li class="has-sub">
                            <a class="js-arrow" href="#">
                                <i class="fas fa-desktop"></i>UI Elements
                            </a>
                            <ul class="navbar-mobile-sub__list list-unstyled js-sub-list">
                                <li>
                                    <a href="button.html">Button</a>
                                </li>
                                <li>
                                    <a href="badge.html">Badges</a>
                                </li>
                                <li>
                                    <a href="tab.html">Tabs</a>
                                </li>
                                <li>
                                    <a href="card.html">Cards</a>
                                </li>
                                <li>
                                    <a href="alert.html">Alerts</a>
                                </li>
                                <li>
                                    <a href="progress-bar.html">Progress Bars</a>
                                </li>
                                <li>
                                    <a href="modal.html">Modals</a>
                                </li>
                                <li>
                                    <a href="switch.html">Switchs</a>
                                </li>
                                <li>
                                    <a href="grid.html">Grids</a>
                                </li>
                                <li>
                                    <a href="fontawesome.html">Fontawesome Icon</a>
                                </li>
                                <li>
                                    <a href="typo.html">Typography</a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </nav>
        </header>
        <div class="sub-header-mobile-2 d-block d-lg-none">
            <div class="header__tool">
                <div class="header-button-item has-noti js-item-menu">
                    <i class="zmdi zmdi-notifications"></i>
                    <div class="notifi-dropdown notifi-dropdown--no-bor js-dropdown">
                        <div class="notifi__title">
                            <p>You have 3 Notifications</p>
                        </div>
                        <div class="notifi__item">
                            <div class="bg-c1 img-cir img-40">
                                <i class="zmdi zmdi-email-open"></i>
                            </div>
                            <div class="content">
                                <p>You got a email notification</p>
                                <span class="date">April 12, 2018 06:50</span>
                            </div>
                        </div>
                        <div class="notifi__item">
                            <div class="bg-c2 img-cir img-40">
                                <i class="zmdi zmdi-account-box"></i>
                            </div>
                            <div class="content">
                                <p>Your account has been blocked</p>
                                <span class="date">April 12, 2018 06:50</span>
                            </div>
                        </div>
                        <div class="notifi__item">
                            <div class="bg-c3 img-cir img-40">
                                <i class="zmdi zmdi-file-text"></i>
                            </div>
                            <div class="content">
                                <p>You got a new file</p>
                                <span class="date">April 12, 2018 06:50</span>
                            </div>
                        </div>
                        <div class="notifi__footer">
                            <a href="#">All notifications</a>
                        </div>
                    </div>
                </div>
                <div class="header-button-item js-item-menu">
                    <i class="zmdi zmdi-settings"></i>
                    <div class="setting-dropdown js-dropdown">
                        <div class="account-dropdown__body">
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-account"></i>Account
                                </a>
                            </div>
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-settings"></i>Setting
                                </a>
                            </div>
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-money-box"></i>Billing
                                </a>
                            </div>
                        </div>
                        <div class="account-dropdown__body">
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-globe"></i>Language
                                </a>
                            </div>
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-pin"></i>Location
                                </a>
                            </div>
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-email"></i>Email
                                </a>
                            </div>
                            <div class="account-dropdown__item">
                                <a href="#">
                                    <i class="zmdi zmdi-notifications"></i>Notifications
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="account-wrap">
                    <div class="account-item account-item--style2 clearfix js-item-menu">
                        <div class="image">
                            <img id="avatarMobileOutside" alt="" />
                        </div>
                        <div class="content">
                            <a id="nameDisplayOutsideMobile" class="js-acc-btn" href="#"></a>
                        </div>
                        <div class="account-dropdown js-dropdown">
                            <div class="info clearfix">
                                <div class="image">
                                    <a href="#">
                                        <img id="avatarMobileInside" alt="" />
                                    </a>
                                </div>
                                <div class="content">
                                    <h5 class="name">
                                        <a id="nameDisplayInsideMobile" href="#"></a>
                                    </h5>
                                    <span id="emailMobile" class="email"></span>
                                </div>
                            </div>
                            <div class="account-dropdown__body">
                                <div class="account-dropdown__item">
                                    <a href="#">
                                        <i class="zmdi zmdi-account"></i>Account
                                    </a>
                                </div>
                                <div class="account-dropdown__item">
                                    <a href="#">
                                        <i class="zmdi zmdi-settings"></i>Setting
                                    </a>
                                </div>
                                <div class="account-dropdown__item">
                                    <a href="#">
                                        <i class="zmdi zmdi-money-box"></i>Billing
                                    </a>
                                </div>
                            </div>
                            <div id="logOut" class="account-dropdown__footer">
                                <a href="#">
                                    <i class="zmdi zmdi-power"></i>Logout
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- END HEADER MOBILE -->
        <!-- PAGE CONTENT-->
        <div class="page-content--bgf7">


            <!-- WELCOME-->
            <section class="welcome p-t-10">
                <div class="container">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="row">
                                <h1 class="title-4">Dashboard</h1>
                                <button id="createFirmwareForm" type="button" class="btn btn-info btn-lg buttonCreate" data-toggle="modal" data-target="#modalCreate">Create</button>
                            </div>
                            <hr class="line-seprate">
                        </div>
                    </div>
                </div>
            </section>
            <!-- END WELCOME-->
            <!-- STATISTIC-->
            <section class="statistic statistic2" style="min-height:80vh">
                <div class="container">
                    <div id="content" class="row">
                    </div>
                </div>
            </section>
            <!-- END STATISTIC-->
            <!-- END STATISTIC CHART-->




        </div>

    </div>

    <!-- Modal Edit-->
    <div class="modal fade" id="modalEdit" role="dialog">
        <div class="modal-dialog">

            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <p>Edit Firmware</p>
                </div>
                <div class="modal-content">
                    <form id="modalContentEdit" class="form-inline" style="padding-top:10px;padding-left:30px">
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Firmware Name">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input type="text" class="form-control" id="firmwareNameEdit" placeholder="a">
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Platform">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input type="text" class="form-control" id="platformEdit" placeholder="a">
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Version">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input type="text" class="form-control" id="versionEdit" placeholder="a">
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Firmware">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input id="fileUploadEdit" type="file" class="btn btn-info" style="width: 230px; font-size:12px" />
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="API Link">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <button id="getClipboardLink" type="button" class="btn btn-info" style="width: 230px; font-size:12px" data-dismiss="modal">Copy link</button>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-warning" data-dismiss="modal" style="margin-right:30px">Close</button>
                    <button id="deleteFirmware" type="button" class="btn btn-danger" data-dismiss="modal" style="margin-right:30px">Delete</button>
                    <button id="updateFirmware" type="button" class="btn btn-success" data-dismiss="modal">Update</button>
                </div>
            </div>

        </div>
    </div>
    <!-- Modal Create-->
    <div class="modal fade" id="modalCreate" role="dialog">
        <div class="modal-dialog">

            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <p>Create Firmware</p>
                </div>
                <div class="modal-content">
                    <form id="modalContentCreate" class="form-inline" style="padding-top:10px;padding-left:30px">
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="firmwareNameModal" value="Firmware Name">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input type="text" class="form-control" id="firmwareNameCreate" placeholder="Firmware">
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Platform">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input type="text" class="form-control" id="platformCreate" placeholder="STM32XXX">
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Version">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input type="text" class="form-control" id="versionCreate" placeholder="0.0.1">
                        </div>
                        <div class="form-group mb-2">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail2" value="Firmware">
                        </div>
                        <div class="form-group mx-sm-3 mb-2">
                            <input id="fileUploadCreate" type="file" class="btn btn-info" style="width: 230px; font-size:12px" />
                        </div>
                    </form>
                </div>
                <div class="modal-footer" id="modalContentCreateFooter">
                    <button type="button" class="btn btn-danger" data-dismiss="modal" style="margin-right:30px">Close</button>
                    <button id="createFirmware" type="button" class="btn btn-success" data-dismiss="modal" disabled>Create</button>
                </div>
            </div>

        </div>
    </div>
    <script id='ele' type="text/template">
        <div id="test" class="col-md-6 col-lg-3" data-toggle="modal" data-target="#modalEdit">
            <div class="statistic__item statistic__item--green">
                <h2 class="number noselect">Firmware 1</h2>
                <h2 class="desc noselect">STM32F107</h2>
                <h2 class="desc noselect">0.0.1</h2>
                <h2 class="desc noselect">Online</h2>
                <div class="icon">
                    <i class="zmdi zmdi-globe"></i>
                </div>
            </div>
        </div>
    </script>

    <!-- Jquery JS-->
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/jquery-3.2.1.min.js"></script>
    <!-- Bootstrap JS-->
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/bootstrap-4.1/popper.min.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/bootstrap-4.1/bootstrap.min.js"></script>
    <!-- Vendor JS       -->
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/slick/slick.min.js">
    </script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/wow/wow.min.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/animsition/animsition.min.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/bootstrap-progressbar/bootstrap-progressbar.min.js">
    </script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/counter-up/jquery.waypoints.min.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/counter-up/jquery.counterup.min.js">
    </script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/circle-progress/circle-progress.min.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/perfect-scrollbar/perfect-scrollbar.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/chartjs/Chart.bundle.min.js"></script>
    <script src="https://upware1.b-cdn.net/dashboardPage/vendor/select2/select2.min.js">
    </script>
    <!-- Main JS-->
    <script type="text/javascript" src="https://upware1.b-cdn.net/dashboardPage/js/main.js"></script>
    <script src="https://www.gstatic.com/firebasejs/5.3.0/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/5.3.0/firebase-firestore.js"></script>

    <script src="https://www.gstatic.com/firebasejs/5.3.0/firebase-auth.js"></script>
    <!--<script type="text/javascript" src="https://upware1.b-cdn.net/Common/js/firebase.js"></script>-->

    <script>
        resultGlobal = null;
        firmwareSelect = null;
        indexElement = 0;
        timerDelete = 255;
        idDelete = null;
        function createFirmwareForm() {
            modalContentCreate = document.getElementById('modalContentCreate');
            modalContentCreate.children[1].children[0].placeholder = 'Firmware';
            modalContentCreate.children[3].children[0].placeholder = 'STM32FXXX';
            modalContentCreate.children[5].children[0].placeholder = '0.0.1';

            modalContentCreate.children[1].children[0].value = '';
            modalContentCreate.children[3].children[0].value = '';
            modalContentCreate.children[5].children[0].value = '';

            document.getElementById('modalContentCreateFooter').children[1].disabled = 'true';
        }
        function elementSelect(id) {
            ////console.log(id);

            modalContentEdit = document.getElementById('modalContentEdit');
            modalContentEdit.children[1].children[0].placeholder = resultGlobal[id].name;
            modalContentEdit.children[3].children[0].placeholder = resultGlobal[id].platform;
            modalContentEdit.children[5].children[0].placeholder = resultGlobal[id].version;

            firmwareSelect = id;
        }
        function checkHexFileUploadedCreate() {
            // Check hex file
            hexFile = document.getElementById("fileUploadCreate").files[0];
            if (hexFile != undefined) {
                hexData = null;
                hexFile.arrayBuffer().then(function (value) {
                    hexData = value;
                    if (hexData.byteLength <= 4194304) {
                        hexArray = new Uint8Array(value);

                        var hexString = new TextDecoder("utf-8").decode(hexArray);
                        ////console.log(hexArray);
                        var obj = {
                            name: 0,
                            version: 0,
                            platform: 0,
                            id: 0,
                            firmwareId: 0,
                            dateTime: 0,
                            userUid: 0,
                            downloads: 0,
                            hexStr: hexString
                        };

                        $.ajax({
                            url: "/main/firmwareUploaded",
                            data: JSON.stringify(obj),
                            type: "POST",
                            contentType: "application/json;charset=utf-8",
                            dataType: "json",
                            success: function (result) {
                                if (result == 'OK:1') {
                                    document.getElementById("createFirmware").disabled = false;
                                }
                                else {
                                    document.getElementById("createFirmware").disabled = true;
                                    alert(result);
                                }

                                //console.log(result);
                            },
                            error: function (errormessage) {
                                document.getElementById("createFirmware").disabled = true;
                                alert("File Error");
                            }
                        });
                    }
                    else {
                        document.getElementById("createFirmware").disabled = true;
                        alert("File too large");
                    }

                });
            }
            else {
                document.getElementById("createFirmware").disabled = true;
            }
        }
        function checkHexFileUploadedEdit() {
            // Check hex file
            hexFile = document.getElementById("fileUploadEdit").files[0];
            if (hexFile != undefined) {
                hexData = null;
                hexFile.arrayBuffer().then(function (value) {
                    hexData = value;
                    if (hexData.byteLength <= 4194304) {
                        hexArray = new Uint8Array(value);

                        var hexString = new TextDecoder("utf-8").decode(hexArray);
                        ////console.log(hexArray);
                        var obj = {
                            name: 0,
                            version: 0,
                            platform: 0,
                            id: 0,
                            firmwareId: 0,
                            dateTime: 0,
                            userUid: 0,
                            downloads: 0,
                            hexStr: hexString
                        };

                        $.ajax({
                            url: "/main/firmwareUploaded",
                            data: JSON.stringify(obj),
                            type: "POST",
                            contentType: "application/json;charset=utf-8",
                            dataType: "json",
                            success: function (result) {
                                if (result == 'OK:1') {
                                    document.getElementById("updateFirmware").disabled = false;
                                }
                                else {
                                    document.getElementById("updateFirmware").disabled = true;
                                    alert(result);
                                }

                                //console.log(result);
                            },
                            error: function (errormessage) {
                                document.getElementById("updateFirmware").disabled = true;
                                alert("File Error");
                            }
                        });
                    }
                    else {
                        document.getElementById("updateFirmware").disabled = true;
                        alert("File too large");
                    }

                });
            }
            else {
                document.getElementById("updateFirmware").disabled = true;
            }
        }
        function updateFirmwareInfo() {
            ////console.log('updateFirmware');
            nameValue = null;
            versionValue = null;
            platformValue = null;
            nameValue = document.getElementById('firmwareNameEdit').value;
            if (nameValue == '') {
                nameValue = document.getElementById('firmwareNameEdit').placeholder;
            }
            versionValue = document.getElementById('versionEdit').value;
            if (versionValue == '') {
                versionValue = document.getElementById('versionEdit').placeholder;
            }
            platformValue = document.getElementById('platformEdit').value;
            if (platformValue == '') {
                platformValue = document.getElementById('platformEdit').placeholder;
            }
            ////console.log(obj);

            // Get hex file
            hexFile = document.getElementById("fileUploadEdit").files[0];
            if (hexFile == undefined) {
                var obj = {
                    name: nameValue,
                    version: versionValue,
                    platform: platformValue,
                    id: 0,
                    firmwareId: resultGlobal[firmwareSelect].firmwareId,
                    dateTime: 0,
                    userUid: 0,
                    downloads: 0,
                    hexStr: 0
                };

                $.ajax({
                    url: "/main/firmwareUpdate",
                    data: JSON.stringify(obj),
                    type: "POST",
                    contentType: "application/json;charset=utf-8",
                    dataType: "json",
                    success: function (result) {
                        document.getElementById(firmwareSelect).children[0].children[0].textContent = nameValue;
                        document.getElementById(firmwareSelect).children[0].children[2].textContent = platformValue;
                        document.getElementById(firmwareSelect).children[0].children[3].textContent = 'Version ' + versionValue;
                    },
                    error: function (errormessage) {
                        alert("File Error");
                    }
                });
            }
            else {
                hexData = null;
                hexFile.arrayBuffer().then(function (value) {
                    hexData = value;
                    if (hexData.byteLength <= 4194304) {
                        hexArray = new Uint8Array(value);

                        var hexString = new TextDecoder("utf-8").decode(hexArray);

                        var obj = {
                            name: nameValue,
                            version: versionValue,
                            platform: platformValue,
                            id: 0,
                            firmwareId: resultGlobal[firmwareSelect].firmwareId,
                            dateTime: 0,
                            userUid: 0,
                            downloads: 0,
                            hexStr: hexString
                        };

                        $.ajax({
                            url: "/main/firmwareUpdate",
                            data: JSON.stringify(obj),
                            type: "POST",
                            contentType: "application/json;charset=utf-8",
                            dataType: "json",
                            success: function (result) {
                                if (result.length == 4) {
                                    document.getElementById(firmwareSelect).children[0].children[0].textContent = nameValue;
                                    document.getElementById(firmwareSelect).children[0].children[2].textContent = platformValue;
                                    document.getElementById(firmwareSelect).children[0].children[3].textContent = 'Version ' + versionValue;
                                }
                                else {
                                    alert(result);
                                }
                            },
                            error: function (errormessage) {
                                alert("File Error");
                            }
                        });
                    }
                    else {
                        alert("File too large");
                    }

                });
            }

        }
        function createFirmware() {
            nameValue = null;
            versionValue = null;
            platformValue = null;
            nameValue = document.getElementById('firmwareNameCreate').value;
            if (nameValue == '') {
                nameValue = document.getElementById('firmwareNameCreate').placeholder;
            }
            versionValue = document.getElementById('versionCreate').value;
            if (versionValue == '') {
                versionValue = document.getElementById('versionCreate').placeholder;
            }
            platformValue = document.getElementById('platformCreate').value;
            if (platformValue == '') {
                platformValue = document.getElementById('platformCreate').placeholder;
            }

            // Get hex file
            hexFile = document.getElementById("fileUploadCreate").files[0];
            if (hexFile == undefined) {
                alert("File not exist!!!");
            }
            else {
                hexData = null;
                hexFile.arrayBuffer().then(function (value) {
                    hexData = value;
                    if (hexData.byteLength <= 4194304) {
                        hexArray = new Uint8Array(value);

                        var hexString = new TextDecoder("utf-8").decode(hexArray);
                        ////console.log(hexArray);
                        var obj = {
                            name: nameValue,
                            version: versionValue,
                            platform: platformValue,
                            id: 0,
                            firmwareId: 0,
                            dateTime: 0,
                            userUid: firebase.auth().currentUser.uid,
                            downloads: 0,
                            hexStr: hexString
                        };
                        //console.log(obj);

                        $.ajax({
                            url: "/main/firmwareCreate",
                            data: JSON.stringify(obj),
                            type: "POST",
                            contentType: "application/json;charset=utf-8",
                            dataType: "json",
                            success: function (result) {
                                //console.log(result);
                                if (result.length == 36) {
                                    if (typeof firmwareElement !== 'undefined') {
                                        firmwareElement++;
                                    }
                                    else {
                                        firmwareElement = 0;
                                    }
                                    elementHTML = e1 + firmwareElement + e2;
                                    //document.getElementById('content').innerHTML += "<div id =\"element\" class=\"col-md-6 col-lg-3\" data-toggle=\"modal\" data-target=\"#modalEdit\"><div class=\"statistic__item statistic__item--green\"><h2 class=\"number noselect\">Firmware 1</h2><h2 class=\"desc noselect\">STM32F107</h2><h2 class=\"desc noselect\">0.0.1</h2><h2 class=\"desc noselect\">Online</h2><div class=\"icon\"><i class=\"zmdi zmdi-globe\"></i></div></div></div>"
                                    document.getElementById('content').innerHTML += elementHTML;

                                    child = document.getElementById(firmwareElement);
                                    child.children[0].children[0].textContent = nameValue;
                                    child.children[0].children[1].textContent = result;
                                    child.children[0].children[2].textContent = platformValue;
                                    child.children[0].children[3].textContent = "Version " + versionValue;
                                    child.children[0].children[4].textContent = "Downloaded " + 0;

                                    obj.firmwareId = result;
                                    resultGlobal.push(obj);
                                }
                                else {
                                    //console.log('error');
                                    //alert(result);
                                }
                            },
                            error: function (errormessage) {
                                //console.log(errormessage);
                                // alert("File Error");
                            }
                        });
                    }
                    else {
                        alert("File too large");
                    }

                });
            }


        }
        function deleteFirmware() {
            var result = confirm("Want to delete?");
            if (result) {
                nameValue = null;
                versionValue = null;
                platformValue = null;
                nameValue = document.getElementById('firmwareNameEdit').value;
                if (nameValue == '') {
                    nameValue = document.getElementById('firmwareNameEdit').placeholder;
                }
                versionValue = document.getElementById('versionEdit').value;
                if (versionValue == '') {
                    versionValue = document.getElementById('versionEdit').placeholder;
                }
                platformValue = document.getElementById('platformEdit').value;
                if (platformValue == '') {
                    platformValue = document.getElementById('platformEdit').placeholder;
                }
                var obj = {
                    name: nameValue,
                    version: versionValue,
                    platform: platformValue,
                    id: 0,
                    firmwareId: resultGlobal[firmwareSelect].firmwareId,
                    dateTime: 0,
                    userUid: 0,
                    downloads: 0
                };
                ////console.log(obj);

                idDelete = firmwareSelect;
                setTimeout(deleteFirmwareAnimation, 10);

                $.ajax({
                    url: "/main/firmwareDelete",
                    data: JSON.stringify(obj),
                    type: "POST",
                    contentType: "application/json;charset=utf-8",
                    dataType: "json",
                    success: function (result) {
                        //loadData();
                        //$('#myModal').modal('hide');
                    },
                    error: function (errormessage) {
                        //alert(errormessage.responseText);
                    }
                });
            }
        }
        function deleteFirmwareAnimation() {
            if (timerDelete > 50) {
                document.getElementById(idDelete).children[0].style.backgroundColor = '#' + timerDelete.toString(16) + '0000';
                setTimeout(deleteFirmwareAnimation, 7);
                timerDelete--;
            }
            else {
                document.getElementById(idDelete).remove();
                timerDelete = 255;
            }
        }
        function userInfoInit() {
            //firebase.auth().onAuthStateChanged(function (user) {
            user = firebase.auth().currentUser;
            document.getElementById('nameDisplayOutsideDesktop').text = user.displayName;
            document.getElementById('nameDisplayInsideDesktop').text = user.displayName;
            document.getElementById('emailDesktop').innerText = user.email;
            document.getElementById('nameDisplayOutsideMobile').text = user.displayName;
            document.getElementById('nameDisplayInsideMobile').text = user.displayName;
            document.getElementById('emailMobile').innerText = user.email;

            document.getElementById('avatarDesktopOutside').src = user.photoURL;
            document.getElementById('avatarDesktopInside').src = user.photoURL;
            document.getElementById('avatarMobileOutside').src = user.photoURL;
            document.getElementById('avatarMobileInside').src = user.photoURL;
            //});
        }
        function contentInit() {
            e1 = "<div id =\"";
            e2 = "\" onClick=\"elementSelect(this.id)\" class=\"col-md-6 col-lg-3\" data-toggle=\"modal\" data-target=\"#modalEdit\"><div class=\"statistic__item statistic__item--green\"><h2 class=\"number noselect\">Firmware 1</h2><h6 class=\"descUid noselect\">firmwareId</h6><h2 class=\"desc noselect\">STM32F107</h2><h2 class=\"desc noselect\">0.0.1</h2><h2 class=\"desc noselect\">Online</h2><div class=\"icon\"><i class=\"zmdi zmdi-globe\"></i></div></div></div>";

            $.ajax({
                url: "/main/Init",
                //data: JSON.stringify(obj),
                type: "GET",
                contentType: "application/json;charset=utf-8",
                dataType: "json",
                success: function (result) {
                    //loadData();
                    //$('#modalEdit').modal('hide');
                    ////console.log(result);
                    resultGlobal = result;

                    for (firmwareElement in result) {
                        //////console.log(firmwareElement.uid);
                        ////console.log(result[firmwareElement]);
                        //document.getElementById('content').innerHTML += document.getElementById('ele').innerHTML;
                        //document.getElementById('content').innerHTML += e1;
                        //document.getElementById('content').innerHTML += firmwareElement;
                        //document.getElementById('content').innerHTML += e2;
                        elementHTML = e1 + firmwareElement + e2;
                        //document.getElementById('content').innerHTML += "<div id =\"element\" class=\"col-md-6 col-lg-3\" data-toggle=\"modal\" data-target=\"#modalEdit\"><div class=\"statistic__item statistic__item--green\"><h2 class=\"number noselect\">Firmware 1</h2><h2 class=\"desc noselect\">STM32F107</h2><h2 class=\"desc noselect\">0.0.1</h2><h2 class=\"desc noselect\">Online</h2><div class=\"icon\"><i class=\"zmdi zmdi-globe\"></i></div></div></div>"
                        document.getElementById('content').innerHTML += elementHTML;

                        child = document.getElementById('content').children[firmwareElement];
                        child.children[0].children[0].textContent = result[firmwareElement].name;
                        child.children[0].children[1].textContent = result[firmwareElement].firmwareId;
                        child.children[0].children[2].textContent = result[firmwareElement].platform;
                        child.children[0].children[3].textContent = "Version " + result[firmwareElement].version;
                        child.children[0].children[4].textContent = "Downloaded " + result[firmwareElement].downloads;
                    }

                    // Init user infomation
                    userInfoInit();
                },
                error: function (errormessage) {
                    //alert(errormessage.responseText);
                    console.log(errormessage);
                    console.log('1');
                    //window.location.href = "/login";
                }
            });
        }
        function copy(text) {
            var input = document.createElement('input');
            input.setAttribute('value', text);
            document.body.appendChild(input);
            input.select();
            var result = document.execCommand('copy');
            document.body.removeChild(input);
            return result;
         }
        function copyClipboardLink() {
            strLink = "http://www.upware.io/api/hex/" + resultGlobal[firmwareSelect].firmwareId.toString().toLowerCase();
            copy(strLink);
        }

        function firebaseLogout() {
            console.log('firebaseLogout');
            firebase.auth().signOut().then(function () {
                ////console.log('SignOut successfull');
                //$.ajax({
                //    url: "/main/userLogout",
                //    data: JSON.stringify(obj),
                //    type: "POST",
                //    contentType: "application/json;charset=utf-8",
                //    dataType: "json",
                //    success: function (result) {
                //        //loadData();
                //        //$('#modalEdit').modal('hide');
                //        ////console.log(result);
                //        ////window.location.href = "/login";
                //    },
                //    error: function (errormessage) {
                //        //alert(errormessage.responseText);
                //    }
                //});
                console.log('2');
                window.location.href = "/login";
            }, function (error) {
                // An error happened.
                ////console.log('SignOut error');
            });

            ////console.log(obj);

        }
        function firebase_init(){
          var config = {
            apiKey: "AIzaSyC7elL3FYPlcVj7PvN9ecGpvVUVg6L1fKg",
            authDomain: "worklist-app.firebaseapp.com",
            databaseURL: "https://worklist-app.firebaseio.com",
            projectId: "worklist-app",
            storageBucket: "worklist-app.appspot.com",
            messagingSenderId: "740341135888"
          };
          firebase.initializeApp(config);

          firebase.firestore().settings({});
        }
        $(document).ready(function () {
            firebase_init();
            firebase.auth().onAuthStateChanged(function(user) {
                if (user) {
                    var user = firebase.auth().currentUser;
                    //console.log(user);
                    var obj = {
                        uid: user.uid,
                        firmwareCount: 0,
                    };
                    //console.log(obj);
                    if (obj.uid != undefined) {
                        $.ajax({
                            url: "/Home/userInit",
                            data: JSON.stringify(obj),
                            type: "POST",
                            contentType: "application/json;charset=utf-8",
                            dataType: "json",
                            success: function (result) {
                                //console.log("user remain");
                                contentInit();
                                //loadData();
                                //$('#myModal').modal('hide');
                            },
                            error: function (errormessage) {
                                //alert(errormessage.responseText);
                                //console.log(errormessage);
                                //console.log(JSON.stringify(obj));
                                console.log(errormessage);
                                console.log('3');
                                //window.location.href = "/login";
                            }
                        });
                    }
                } else {
                    console.log('4');
                    window.location.href = "/login";
                }
            });


            //document.getElementById('content').innerHTML += document.getElementById('ele').innerHTML;
            document.getElementById('logOut').addEventListener('click', firebaseLogout);
            document.getElementById('logOut').addEventListener('touchstart', firebaseLogout);

            // Add event to button modified firmware info
            document.getElementById('updateFirmware').addEventListener('click', updateFirmwareInfo);

            // Add event to button create firmware
            document.getElementById('createFirmware').addEventListener('click', createFirmware);

            // Add event to delete firmware element
            document.getElementById('deleteFirmware').addEventListener('click', deleteFirmware);

            // Add event to display form to create firmware element
            document.getElementById('createFirmwareForm').addEventListener('click', createFirmwareForm);

            // Add event to copy api link to clipboard
            document.getElementById('getClipboardLink').addEventListener('click', copyClipboardLink);

            $("#fileUploadCreate").on('change', checkHexFileUploadedCreate);

            $("#fileUploadEdit").on('change', checkHexFileUploadedEdit);
        });
    </script>



</body>

</html>
<!-- end document-->
